<html>

<head>
    <style>
        .eventer-ticket-printable {
            margin: 10px auto 50px;
            width: 300px
        }

        .eventer-ticket-image_create .eventer-ticket-printable {
            width: 600px
        }

        .eventer-ticket-printable-top,
        .eventer-ticket-printable-bottom {
            background-color: #fff;
            border-radius: 12px;
            padding: 20px;
            border: 1px solid #eee;
            box-shadow: 0 5px 35px rgba(0, 0, 0, .06)
        }

        .eventer-ticket-printable-top {
            border-bottom: 0;
            text-align: center
        }

        .eventer-ticket-printable-bottom {
            border-top: 1px dashed #ccc
        }

        .eventer .eventer-ticket-printable label {
            font-size: 12px !important;
            margin: 0 0 5px !important;
            padding: 0 !important;
            color: #ccc
        }

        .eventer.eventer-print-window .eventer-ticket-printable label {
            color: #999
        }

        .eventer-ticket-printable {
            font-size: 13px !important
        }

        .eventer-ticket-printable p {
            margin: 0 0 5px !important;
            padding: 0 !important
        }

        .eventer-ticket-printable h3 {
            font-size: 15px !important;
            margin: 0 0 10px !important;
            padding: 0 !important;
            font-weight: 400 !important;
            margin-top: 4px
        }

        .eventer-on-ticket-qr img {
            width: 100px !important
        }

        .eventer-ticket-c-logo img {
            height: auto;
            max-width: 100%
        }

        .eventer-ticket-c-info {
            padding: 15px 0 0;
            margin-top: 15px;
            border-top: 1px solid #eee
        }

        .eventer-ticket-image_create .eventer-qrcode img {
            width: 200px !important
        }

        .eventer .eventer-ticket-image_create .eventer-ticket-printable label {
            font-size: 20px !important;
            margin-bottom: 5 !important
        }

        .eventer .eventer-ticket-image_create .eventer-ticket-printable {
            font-size: 24px !important
        }

        .eventer-ticket-image_create .eventer-ticket-printable p {
            margin-bottom: 10px !important;
            margin-top: 0 !important;
            line-height: 30px !important
        }

        .eventer-ticket-image_create .eventer-ticket-printable h3 {
            font-size: 30px !important;
            margin-bottom: 30px !important
        }

        .eventer-ticket-image_create .eventer-ticket-printable-top,
        .eventer-ticket-image_create .eventer-ticket-printable-bottom {
            padding: 40px;
            border-color: #ccc;
            border-radius: 15px
        }

        .eventer-ticket-image_create .eventer-ticket-printable-bottom {
            padding-bottom: 20px
        }
    </style>
</head>

<body>
    <div class="eventer-ticket-final-tickets">
        <div class="eventer-ticket-printable">
            <div class="eventer-ticket-printable-top">
                <?php if ( isset( $barcode ) && $barcode ) : ?>
                    <div class="eventer-qrcode eventer-on-ticket-qr" data-qr-content=""><img src="<?php echo $barcode; ?>">
                    </div>
                <?php endif; ?>
                <?php if ( isset( $code ) && $code ) : ?>
                    <label class="eventer-ticket-reg-code">
                        <?php echo $code; ?>
                    </label>
                <?php endif; ?>
            </div>
            <div class="eventer-ticket-printable-bottom">
                <?php if ( isset( $attendee_name ) && $attendee_name ) : ?>
                    <label>Attendee</label>
                    <h3>
                        <?php echo $attendee_name; ?>
                    </h3>
                <?php endif; ?>
                <div class="eventer-spacer-10"></div>
                <?php if ( isset( $event_name ) && $event_name ) : ?>
                    <label>Event</label>
                    <p class="eventer-woo-title">
                        <?php echo $event_name; ?>
                    </p>
                <?php endif; ?>
                <div class="eventer-spacer-10"></div>
                <?php if ( isset( $ticket ) && $ticket ) : ?>
                    <label>Ticket</label>
                    <p class="registrant-ticket">
                        <?php echo $ticket; ?>
                    </p>
                <?php endif; ?>
                <div class="eventer-spacer-20"></div>
                <div class="eventer-row">
                    <?php if ( isset( $location ) && $location ) : ?>
                        <div class="eventer-col5 eventer-pt-venue">
                            <label>Venue Location</label>
                            <p class="eventer-woo-location">
                                <?php echo $location; ?>
                            </p>
                        </div>
                    <?php endif; ?>
                    <div class="eventer-col5 eventer-pt-datetime">
                        <?php if ( isset( $time ) && $time ) : ?>
                            <label>Date &amp; Time</label>
                            <p class="eventer-woo-datetime">
                                <?php echo $time; ?>
                                <br>
                                <?php if ( $event_cdate ) : ?>
                                    <?php echo $event_cdate; ?>
                                <?php endif; ?>
                            </p>
                        <?php endif; ?>
                    </div>
                </div>
                <?php if ( isset( $notes ) && $notes) { ?>
                    <div class="eventer-spacer-10"></div>
                    <div class="eventer-row">
                        <div class="eventer-col10 eventer-pt-instructions">
                            <label>Instructions</label>
                            <p>
                                <?php echo $notes; ?>
                            </p>
                        </div>
                    </div>
                <?php } ?>
                <div class="eventer-spacer-10"></div>
                <div class="eventer-row eventer-ticket-c-info">
                    <div class="eventer-col10 eventer-pt-cominfo">
                        <?php
                        if ($company_image) {
                            echo '<p class="eventer-ticket-c-logo"><img src="' . $company_image . '"></p>';
                        }
                        if ($company_name) {
                            echo '<p class="eventer-ticket-c-address">' . $company_name . '</p>';
                        }
                        if ($company_address) {
                            echo '<p class="eventer-ticket-c-address">' . $company_address . '</p>';
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

</html>